part of tecfy_corev2_client_package;

class MapService {
  static void updateValue(
      Map<String, dynamic> data, String prop, dynamic value) {
    updateValueEx(data, prop.split('.'), 0, value);
  }

  static void updateValueEx(
      Map<String, dynamic> data, List<String> props, int index, dynamic value) {
    // if last prop
    if (index == props.length - 1) {
      data[props[index]] = value;
    } else {
      if (data[props[index]] == null) {
        data[props[index]] = <String, dynamic>{};
      } else {
        data[props[index]] = data[props[index]].map<String, dynamic>(
            (key, value) => MapEntry<String, dynamic>(key.toString(), value));
      }

      updateValueEx(data[props[index]], props, index + 1, value);
    }
  }

  static dynamic getValue(Map<dynamic, dynamic> data, String props) {
    return getValueEx(data, props.split('.'), 0);
  }

  static dynamic getValueEx(
      Map<dynamic, dynamic> data, List<String> props, int index) {
    // if last prop
    if (index == props.length - 1) {
      return data[props[index]];
    } else {
      if (data[props[index]] == null) {
        return null;
      } else {
        data[props[index]] = data[props[index]].map<String, dynamic>(
            (key, value) => MapEntry<String, dynamic>(key.toString(), value));
      }
      return getValueEx(data[props[index]], props, index + 1);
    }
  }
}
